<template>
  <div class="home-page">
    <HomeIntroSection v-if="home_data" :home_data="home_data" />
    <StudentWorkSection :student_works="student_works" />
    <HomeVisionSection :home_data="home_data" />
    <template
      v-if="
        built_environment_programs.length > 0 ||
        built_environment_non_programs.length > 0
      "
    >
      <SectionTitle title="Programs in Built Environment" />
      <div class="program-group">
        <ProgramList
          v-if="built_environment_programs.length > 0"
          title="Degree Program"
          style="border-top: 0"
          :data="built_environment_programs"
        />
        <ProgramList
          v-if="built_environment_non_programs.length > 0"
          title="Non-degree Program"
          style="border-top: 0"
          :data="built_environment_non_programs"
        />
      </div>
    </template>
    <template
      v-if="
        design_strategy_programs.length > 0 ||
        design_strategy_non_programs.length > 0
      "
    >
      <SectionTitle title="Programs in Design & Strategy" />
      <div class="program-group">
        <ProgramList
          v-if="design_strategy_programs.length > 0"
          title="Degree Program"
          style="border-top: 0"
          :data="design_strategy_programs"
        />
        <ProgramList
          v-if="design_strategy_non_programs.length > 0"
          title="Non-degree Program"
          style="border-top: 0"
          :data="design_strategy_non_programs"
        />
      </div>
    </template>
    <template v-if="event_data.length > 0">
      <SectionTitle title="Events" />
      <EventList :data="event_data" />
    </template>
    <template v-if="announcement_data.length > 0">
      <SectionTitle title="Announcements" />
      <NewsList :data="announcement_data" />
    </template>
    <template v-if="services.length > 0">
      <SectionTitle title="Others" />
      <ServiceList :services="services" />
    </template>
  </div>
</template>

<script>
import _ from "lodash";
import qs from "qs";
import moment from "moment";
import { mapMutations } from "vuex";

export default {
  data() {
    return {
      built_environment_programs: [],
      design_strategy_programs: [],
      services: [],
      home_data: null,
      event_data: [],
      announcement_data: [],
      built_environment_non_programs: [],
      design_strategy_non_programs: [],
      student_works: [],
    };
  },
  async mounted() {
    this.setAppLoading(true);
    await Promise.all([
      this.getBuiltEnvironmentPrograms(),
      this.getDesignStrategyPrograms(),
      this.getServices(),
      this.getHomeData(),
      this.getEventData(),
      this.getAnnouncementData(),
      this.getBuiltEnvironmentNonPrograms(),
      this.getDesignStrategyNonPrograms(),
    ]);
    this.setAppLoading(false);
  },
  methods: {
    ...mapMutations(["setAppLoading"]),
    async getBuiltEnvironmentPrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          filters: {
            program_in: {
              $eq: "program in built environment",
            },
          },
          sort: ["id:asc"],
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/programs?${query}`);
        let data = _.get(res, "data");

        this.built_environment_programs = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.title"),
            description: _.get(d, "attributes.description"),
            image:
              process.env.api_url +
              _.get(
                d,
                "attributes.overview_slider_images.data[0].attributes.url"
              ),
            url: `/programs/${d.id}`,
          };
        });
      } catch (error) {
        console.log("getBuiltEnvironmentPrograms ~ error:", error);
      }
    },
    async getDesignStrategyPrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          filters: {
            program_in: {
              $eq: "program in design & strategy",
            },
          },
          sort: ["id:asc"],
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/programs?${query}`);
        let data = _.get(res, "data");

        this.design_strategy_programs = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.title"),
            description: _.get(d, "attributes.description"),
            image:
              process.env.api_url +
              _.get(
                d,
                "attributes.overview_slider_images.data[0].attributes.url"
              ),
            url: `/programs/${d.id}`,
          };
        });
      } catch (error) {
        console.log("getDesignStrategyPrograms ~ error:", error);
      }
    },
    async getServices() {
      const query = qs.stringify(
        {
          populate: "*",
          pagination: {
            limit: 10,
          },
          sort: ["date:desc"],
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/services?${query}`);
        let data = _.get(res, "data");

        this.services = _.map(data, (d) => {
          return {
            ...d,
            url:
              _.get(d, "attributes.type") === "internal"
                ? `/others/${d.id}`
                : _.get(d, "attributes.link"),
          };
        });
      } catch (error) {
        console.log("getServices ~ error:", error);
      }
    },
    async getHomeData() {
      const query = qs.stringify(
        {
          populate: ["student_archives.image", "student_archives.program"],
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/homepage?${query}`);
        this.home_data = _.get(res, "data");
        this.student_works =
          _.get(this.home_data, "attributes.student_archives.data") || [];
      } catch (error) {
        console.log("getHomeData ~ error:", error);
      }
    },
    async getEventData() {
      const query = qs.stringify(
        {
          populate: "*",
          sort: ["date:desc"],
          pagination: {
            limit: 10,
          },
          filters: {
            date: {
              $gte: moment().toISOString(),
            },
          },
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/events?${query}`);
        let data = _.get(res, "data");

        this.event_data = _.map(data, (d) => {
          return {
            id: _.get(d, "id"),
            ..._.get(d, "attributes"),
            image:
              process.env.api_url +
              _.get(d, "attributes.image.data.attributes.url"),
          };
        });
      } catch (error) {
        console.log("getEventData ~ error:", error);
      }
    },
    async getAnnouncementData() {
      const query = qs.stringify(
        {
          populate: "*",
          sort: ["createdAt:desc"],
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/announcements?${query}`);
        let data = _.get(res, "data");

        this.announcement_data = _.map(data, (d) => {
          return {
            id: _.get(d, "id"),
            ..._.get(d, "attributes"),
          };
        });
      } catch (error) {
        console.log("getAnnouncementData ~ error:", error);
      }
    },
    async getBuiltEnvironmentNonPrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          filters: {
            program_in: {
              $eq: "programs in built environment",
            },
          },
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/non-deegree-programs?${query}`);
        let data = _.get(res, "data");

        this.built_environment_non_programs = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.name"),
            description: _.get(d, "attributes.description"),
            url: _.get(d, "attributes.url"),
            image:
              process.env.api_url +
              _.get(d, "attributes.image.data.attributes.url"),
            link_type: "external",
          };
        });
      } catch (error) {
        console.log("getBuiltEnvironmentNonPrograms ~ error:", error);
      }
    },
    async getDesignStrategyNonPrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          filters: {
            program_in: {
              $eq: "programs in design & strategy",
            },
          },
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/non-deegree-programs?${query}`);
        let data = _.get(res, "data");

        this.design_strategy_non_programs = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.name"),
            description: _.get(d, "attributes.description"),
            url: _.get(d, "attributes.url"),
            image:
              process.env.api_url +
              _.get(d, "attributes.image.data.attributes.url"),
            link_type: "external",
          };
        });
      } catch (error) {
        console.log("getDesignStrategyNonPrograms ~ error:", error);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.home-page {
  .program-group {
    padding-top: 40px;
    border-top: 1px solid $color-primary-500;
  }
  .event-list {
    overflow-x: auto;
    ::v-deep {
      .container {
        .event-wrap {
          flex-wrap: nowrap;
          margin: 0;
          .event {
            width: 320px;
            padding: 0 24px 0 0;
            flex: none;
            @include media-breakpoint(mobile) {
              width: 100%;
              padding: 0;
            }
          }
        }
      }
    }
  }
}
</style>
